package ocean.gateway.routes;

import static org.junit.Assert.assertThat;

import java.net.URI;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.cloud.gateway.route.Route;
import org.springframework.cloud.gateway.route.RouteLocator;
import org.springframework.cloud.gateway.route.builder.RouteLocatorBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.http.server.reactive.HttpHandler;
import org.springframework.http.server.reactive.ReactorHttpHandlerAdapter;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.util.Assert;
import org.springframework.web.reactive.function.server.RouterFunction;
import org.springframework.web.reactive.function.server.RouterFunctions;

import lombok.extern.slf4j.Slf4j;
import ocean.gateway.service.ServiceApplication;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.netty.DisposableServer;
import reactor.netty.http.server.HttpServer;
import reactor.netty.http.server.HttpServerRequest;


@RunWith(SpringRunner.class)
@SpringBootTest(classes = { ServiceApplication.class }, webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
public class BusinessTests {

	// @RestController
	// @RequestMapping(value = "/my")
	// public class MyController {
	// @RequestMapping(value = "/integration/{name}", method = RequestMethod.GET)
	// public String integrationTest(@PathVariable String name) {
	// return "name:" + name;
	// }
	// }

	public HttpServer server;
	private String serverPort;
	DisposableServer ds;

	// @BeforeClass
	// public void setup(){
	// 	serverPort = "3023";
	// 	server = HttpServer.create().host("http://localhost").port(3023);
	// 	server.route(routes -> routes.get("/test123", (req, res) -> res.sendString(Flux.just("test123"))));
	// 	ds =  server.bind().block();
		
	// 	System.out.println("123");
	// }

	// @AfterClass
	// public void stop()	{ 
	// 	if(server != null) {
	// 		ds.dispose();
	// 	}
	// }

	@Autowired
    private TestRestTemplate restTemplate ;

	@Test
	public void TestRouteLocator() {

		serverPort = "3023";
		server = HttpServer.create().host("http://localhost").port(3023);
		server.route(routes -> routes.get("/test123", (req, res) -> res.sendString(Flux.just("test123"))));
		server.bind().block();

		String baseUri = "http://127.0.0.1:3023";


		ResponseEntity<String> response = restTemplate.getForEntity(baseUri +"/test123", String.class);
        Assert.notNull(response, "The class must not be null");
        Assert.state(response.getStatusCode() == HttpStatus.UNAUTHORIZED, "response.getStatusCode() must be HttpStatus.UNAUTHORIZED");
	}

	

	// @Configuration
	// public class HttpServerConfig {
	// @Autowired
	// private Environment environment;
	// private String serverPort;
	// @Bean
	// public HttpServer httpServer() {
	// 	HttpServer server = HttpServer.create().host("http://localhost:" + serverPort);
	// 	server.handle((req, res) -> res.sendString(Flux.just("HelloTest")));
	// 	return server;
	// 	}
	// }





}

